// IWYU pragma: private, include "nvim/option_defs.h"

/// "indir" values for buffer-local options.
/// These need to be defined globally, so that the BV_COUNT can be used with
/// b_p_script_stx[].
enum {
  BV_AI = 0,
  BV_AR = 1,
  BV_BKC = 2,
  BV_BIN = 3,
  BV_BOMB = 4,
  BV_BH = 5,
  BV_BL = 6,
  BV_BT = 7,
  BV_CHANNEL = 8,
  BV_CIN = 9,
  BV_CINK = 10,
  BV_CINO = 11,
  BV_CINSD = 12,
  BV_CINW = 13,
  BV_COM = 14,
  BV_CMS = 15,
  BV_CPT = 16,
  BV_CFU = 17,
  BV_COT = 18,
  BV_CSL = 19,
  BV_CI = 20,
  BV_DEF = 21,
  BV_DICT = 22,
  BV_EOF = 23,
  BV_EOL = 24,
  BV_EP = 25,
  BV_EFM = 26,
  BV_ET = 27,
  BV_FENC = 28,
  BV_FF = 29,
  BV_FT = 30,
  BV_FFU = 31,
  BV_FIXEOL = 32,
  BV_FEX = 33,
  BV_FLP = 34,
  BV_FO = 35,
  BV_FP = 36,
  BV_GP = 37,
  BV_IMI = 38,
  BV_IMS = 39,
  BV_INC = 40,
  BV_INEX = 41,
  BV_INDE = 42,
  BV_INDK = 43,
  BV_INF = 44,
  BV_ISK = 45,
  BV_KMAP = 46,
  BV_KP = 47,
  BV_LISP = 48,
  BV_LOP = 49,
  BV_LW = 50,
  BV_MENC = 51,
  BV_MP = 52,
  BV_MPS = 53,
  BV_ML = 54,
  BV_MA = 55,
  BV_MOD = 56,
  BV_NF = 57,
  BV_OFU = 58,
  BV_PATH = 59,
  BV_PI = 60,
  BV_QE = 61,
  BV_RO = 62,
  BV_SCBK = 63,
  BV_SW = 64,
  BV_SI = 65,
  BV_STS = 66,
  BV_SPC = 67,
  BV_SPF = 68,
  BV_SPL = 69,
  BV_SPO = 70,
  BV_SUA = 71,
  BV_SWF = 72,
  BV_SMC = 73,
  BV_SYN = 74,
  BV_TS = 75,
  BV_TC = 76,
  BV_TFU = 77,
  BV_TAGS = 78,
  BV_TW = 79,
  BV_TSR = 80,
  BV_TSRFU = 81,
  BV_UDF = 82,
  BV_UL = 83,
  BV_VSTS = 84,
  BV_VTS = 85,
  BV_WM = 86,
  BV_COUNT = 87,  ///< must be the last one
};

/// "indir" values for window-local options.
/// These need to be defined globally, so that the WV_COUNT can be used in the
/// window structure.
enum {
  WV_ARAB = 0,
  WV_BRI = 1,
  WV_BRIOPT = 2,
  WV_CC = 3,
  WV_COCU = 4,
  WV_COLE = 5,
  WV_CRBIND = 6,
  WV_CUC = 7,
  WV_CUL = 8,
  WV_CULOPT = 9,
  WV_DIFF = 10,
  WV_FCS = 11,
  WV_FDC = 12,
  WV_FEN = 13,
  WV_FDE = 14,
  WV_FDI = 15,
  WV_FDL = 16,
  WV_FMR = 17,
  WV_FDM = 18,
  WV_FML = 19,
  WV_FDN = 20,
  WV_FDT = 21,
  WV_LBR = 22,
  WV_LIST = 23,
  WV_LCS = 24,
  WV_NU = 25,
  WV_NUW = 26,
  WV_PVW = 27,
  WV_RNU = 28,
  WV_RL = 29,
  WV_RLC = 30,
  WV_SCROLL = 31,
  WV_SCBIND = 32,
  WV_SO = 33,
  WV_SBR = 34,
  WV_SISO = 35,
  WV_SCL = 36,
  WV_SMS = 37,
  WV_SPELL = 38,
  WV_STC = 39,
  WV_STL = 40,
  WV_VE = 41,
  WV_WBR = 42,
  WV_WINBL = 43,
  WV_WFB = 44,
  WV_WFH = 45,
  WV_WFW = 46,
  WV_WINHL = 47,
  WV_WRAP = 48,
  WV_COUNT = 49,  ///< must be the last one
};

typedef enum {
  kOptInvalid = -1,
  kOptAleph = 0,
  kOptAllowrevins = 1,
  kOptAmbiwidth = 2,
  kOptArabic = 3,
  kOptArabicshape = 4,
  kOptAutochdir = 5,
  kOptAutoindent = 6,
  kOptAutoread = 7,
  kOptAutowrite = 8,
  kOptAutowriteall = 9,
  kOptBackground = 10,
  kOptBackspace = 11,
  kOptBackup = 12,
  kOptBackupcopy = 13,
  kOptBackupdir = 14,
  kOptBackupext = 15,
  kOptBackupskip = 16,
  kOptBelloff = 17,
  kOptBinary = 18,
  kOptBomb = 19,
  kOptBreakat = 20,
  kOptBreakindent = 21,
  kOptBreakindentopt = 22,
  kOptBrowsedir = 23,
  kOptBufhidden = 24,
  kOptBuflisted = 25,
  kOptBuftype = 26,
  kOptCasemap = 27,
  kOptCdhome = 28,
  kOptCdpath = 29,
  kOptCedit = 30,
  kOptChannel = 31,
  kOptCharconvert = 32,
  kOptCindent = 33,
  kOptCinkeys = 34,
  kOptCinoptions = 35,
  kOptCinscopedecls = 36,
  kOptCinwords = 37,
  kOptClipboard = 38,
  kOptCmdheight = 39,
  kOptCmdwinheight = 40,
  kOptColorcolumn = 41,
  kOptColumns = 42,
  kOptComments = 43,
  kOptCommentstring = 44,
  kOptCompatible = 45,
  kOptComplete = 46,
  kOptCompletefunc = 47,
  kOptCompleteitemalign = 48,
  kOptCompleteopt = 49,
  kOptCompleteslash = 50,
  kOptConcealcursor = 51,
  kOptConceallevel = 52,
  kOptConfirm = 53,
  kOptCopyindent = 54,
  kOptCpoptions = 55,
  kOptCursorbind = 56,
  kOptCursorcolumn = 57,
  kOptCursorline = 58,
  kOptCursorlineopt = 59,
  kOptDebug = 60,
  kOptDefine = 61,
  kOptDelcombine = 62,
  kOptDictionary = 63,
  kOptDiff = 64,
  kOptDiffexpr = 65,
  kOptDiffopt = 66,
  kOptDigraph = 67,
  kOptDirectory = 68,
  kOptDisplay = 69,
  kOptEadirection = 70,
  kOptEdcompatible = 71,
  kOptEmoji = 72,
  kOptEncoding = 73,
  kOptEndoffile = 74,
  kOptEndofline = 75,
  kOptEqualalways = 76,
  kOptEqualprg = 77,
  kOptErrorbells = 78,
  kOptErrorfile = 79,
  kOptErrorformat = 80,
  kOptEventignore = 81,
  kOptExpandtab = 82,
  kOptExrc = 83,
  kOptFileencoding = 84,
  kOptFileencodings = 85,
  kOptFileformat = 86,
  kOptFileformats = 87,
  kOptFileignorecase = 88,
  kOptFiletype = 89,
  kOptFillchars = 90,
  kOptFindfunc = 91,
  kOptFixendofline = 92,
  kOptFoldclose = 93,
  kOptFoldcolumn = 94,
  kOptFoldenable = 95,
  kOptFoldexpr = 96,
  kOptFoldignore = 97,
  kOptFoldlevel = 98,
  kOptFoldlevelstart = 99,
  kOptFoldmarker = 100,
  kOptFoldmethod = 101,
  kOptFoldminlines = 102,
  kOptFoldnestmax = 103,
  kOptFoldopen = 104,
  kOptFoldtext = 105,
  kOptFormatexpr = 106,
  kOptFormatlistpat = 107,
  kOptFormatoptions = 108,
  kOptFormatprg = 109,
  kOptFsync = 110,
  kOptGdefault = 111,
  kOptGrepformat = 112,
  kOptGrepprg = 113,
  kOptGuicursor = 114,
  kOptGuifont = 115,
  kOptGuifontwide = 116,
  kOptGuioptions = 117,
  kOptGuitablabel = 118,
  kOptGuitabtooltip = 119,
  kOptHelpfile = 120,
  kOptHelpheight = 121,
  kOptHelplang = 122,
  kOptHidden = 123,
  kOptHighlight = 124,
  kOptHistory = 125,
  kOptHkmap = 126,
  kOptHkmapp = 127,
  kOptHlsearch = 128,
  kOptIcon = 129,
  kOptIconstring = 130,
  kOptIgnorecase = 131,
  kOptImcmdline = 132,
  kOptImdisable = 133,
  kOptIminsert = 134,
  kOptImsearch = 135,
  kOptInccommand = 136,
  kOptInclude = 137,
  kOptIncludeexpr = 138,
  kOptIncsearch = 139,
  kOptIndentexpr = 140,
  kOptIndentkeys = 141,
  kOptInfercase = 142,
  kOptInsertmode = 143,
  kOptIsfname = 144,
  kOptIsident = 145,
  kOptIskeyword = 146,
  kOptIsprint = 147,
  kOptJoinspaces = 148,
  kOptJumpoptions = 149,
  kOptKeymap = 150,
  kOptKeymodel = 151,
  kOptKeywordprg = 152,
  kOptLangmap = 153,
  kOptLangmenu = 154,
  kOptLangnoremap = 155,
  kOptLangremap = 156,
  kOptLaststatus = 157,
  kOptLazyredraw = 158,
  kOptLinebreak = 159,
  kOptLines = 160,
  kOptLinespace = 161,
  kOptLisp = 162,
  kOptLispoptions = 163,
  kOptLispwords = 164,
  kOptList = 165,
  kOptListchars = 166,
  kOptLoadplugins = 167,
  kOptMagic = 168,
  kOptMakeef = 169,
  kOptMakeencoding = 170,
  kOptMakeprg = 171,
  kOptMatchpairs = 172,
  kOptMatchtime = 173,
  kOptMaxcombine = 174,
  kOptMaxfuncdepth = 175,
  kOptMaxmapdepth = 176,
  kOptMaxmempattern = 177,
  kOptMenuitems = 178,
  kOptMkspellmem = 179,
  kOptModeline = 180,
  kOptModelineexpr = 181,
  kOptModelines = 182,
  kOptModifiable = 183,
  kOptModified = 184,
  kOptMore = 185,
  kOptMouse = 186,
  kOptMousefocus = 187,
  kOptMousehide = 188,
  kOptMousemodel = 189,
  kOptMousemoveevent = 190,
  kOptMousescroll = 191,
  kOptMouseshape = 192,
  kOptMousetime = 193,
  kOptNrformats = 194,
  kOptNumber = 195,
  kOptNumberwidth = 196,
  kOptOmnifunc = 197,
  kOptOpendevice = 198,
  kOptOperatorfunc = 199,
  kOptPackpath = 200,
  kOptParagraphs = 201,
  kOptPaste = 202,
  kOptPastetoggle = 203,
  kOptPatchexpr = 204,
  kOptPatchmode = 205,
  kOptPath = 206,
  kOptPreserveindent = 207,
  kOptPreviewheight = 208,
  kOptPreviewwindow = 209,
  kOptPrompt = 210,
  kOptPumblend = 211,
  kOptPumheight = 212,
  kOptPumwidth = 213,
  kOptPyxversion = 214,
  kOptQuickfixtextfunc = 215,
  kOptQuoteescape = 216,
  kOptReadonly = 217,
  kOptRedrawdebug = 218,
  kOptRedrawtime = 219,
  kOptRegexpengine = 220,
  kOptRelativenumber = 221,
  kOptRemap = 222,
  kOptReport = 223,
  kOptRevins = 224,
  kOptRightleft = 225,
  kOptRightleftcmd = 226,
  kOptRuler = 227,
  kOptRulerformat = 228,
  kOptRuntimepath = 229,
  kOptScroll = 230,
  kOptScrollback = 231,
  kOptScrollbind = 232,
  kOptScrolljump = 233,
  kOptScrolloff = 234,
  kOptScrollopt = 235,
  kOptSections = 236,
  kOptSecure = 237,
  kOptSelection = 238,
  kOptSelectmode = 239,
  kOptSessionoptions = 240,
  kOptShada = 241,
  kOptShadafile = 242,
  kOptShell = 243,
  kOptShellcmdflag = 244,
  kOptShellpipe = 245,
  kOptShellquote = 246,
  kOptShellredir = 247,
  kOptShellslash = 248,
  kOptShelltemp = 249,
  kOptShellxescape = 250,
  kOptShellxquote = 251,
  kOptShiftround = 252,
  kOptShiftwidth = 253,
  kOptShortmess = 254,
  kOptShowbreak = 255,
  kOptShowcmd = 256,
  kOptShowcmdloc = 257,
  kOptShowfulltag = 258,
  kOptShowmatch = 259,
  kOptShowmode = 260,
  kOptShowtabline = 261,
  kOptSidescroll = 262,
  kOptSidescrolloff = 263,
  kOptSigncolumn = 264,
  kOptSmartcase = 265,
  kOptSmartindent = 266,
  kOptSmarttab = 267,
  kOptSmoothscroll = 268,
  kOptSofttabstop = 269,
  kOptSpell = 270,
  kOptSpellcapcheck = 271,
  kOptSpellfile = 272,
  kOptSpelllang = 273,
  kOptSpelloptions = 274,
  kOptSpellsuggest = 275,
  kOptSplitbelow = 276,
  kOptSplitkeep = 277,
  kOptSplitright = 278,
  kOptStartofline = 279,
  kOptStatuscolumn = 280,
  kOptStatusline = 281,
  kOptSuffixes = 282,
  kOptSuffixesadd = 283,
  kOptSwapfile = 284,
  kOptSwitchbuf = 285,
  kOptSynmaxcol = 286,
  kOptSyntax = 287,
  kOptTabclose = 288,
  kOptTabline = 289,
  kOptTabpagemax = 290,
  kOptTabstop = 291,
  kOptTagbsearch = 292,
  kOptTagcase = 293,
  kOptTagfunc = 294,
  kOptTaglength = 295,
  kOptTagrelative = 296,
  kOptTags = 297,
  kOptTagstack = 298,
  kOptTermbidi = 299,
  kOptTermencoding = 300,
  kOptTermguicolors = 301,
  kOptTermpastefilter = 302,
  kOptTermsync = 303,
  kOptTerse = 304,
  kOptTextwidth = 305,
  kOptThesaurus = 306,
  kOptThesaurusfunc = 307,
  kOptTildeop = 308,
  kOptTimeout = 309,
  kOptTimeoutlen = 310,
  kOptTitle = 311,
  kOptTitlelen = 312,
  kOptTitleold = 313,
  kOptTitlestring = 314,
  kOptTtimeout = 315,
  kOptTtimeoutlen = 316,
  kOptTtyfast = 317,
  kOptUndodir = 318,
  kOptUndofile = 319,
  kOptUndolevels = 320,
  kOptUndoreload = 321,
  kOptUpdatecount = 322,
  kOptUpdatetime = 323,
  kOptVarsofttabstop = 324,
  kOptVartabstop = 325,
  kOptVerbose = 326,
  kOptVerbosefile = 327,
  kOptViewdir = 328,
  kOptViewoptions = 329,
  kOptVirtualedit = 330,
  kOptVisualbell = 331,
  kOptWarn = 332,
  kOptWhichwrap = 333,
  kOptWildchar = 334,
  kOptWildcharm = 335,
  kOptWildignore = 336,
  kOptWildignorecase = 337,
  kOptWildmenu = 338,
  kOptWildmode = 339,
  kOptWildoptions = 340,
  kOptWinaltkeys = 341,
  kOptWinbar = 342,
  kOptWinblend = 343,
  kOptWindow = 344,
  kOptWinfixbuf = 345,
  kOptWinfixheight = 346,
  kOptWinfixwidth = 347,
  kOptWinheight = 348,
  kOptWinhighlight = 349,
  kOptWinminheight = 350,
  kOptWinminwidth = 351,
  kOptWinwidth = 352,
  kOptWrap = 353,
  kOptWrapmargin = 354,
  kOptWrapscan = 355,
  kOptWrite = 356,
  kOptWriteany = 357,
  kOptWritebackup = 358,
  kOptWritedelay = 359,
  // Option count, used when iterating through options
#define kOptIndexCount 360
} OptIndex;

